#ifndef CRBASE_H_
#define CRBASE_H_
#include "Actor.h"
//#include <OpenThreads/Mutex>
#include <pthread.h>

class CRBase: public Actor
{
public:
	CRBase();

	~CRBase();

	string handle_synch(string sender, string message);

	virtual string ask(string constraintType, string role, string operation,
		string parameters, string senderRole, string receiverRole) = 0;

	virtual void updateState(string stateName,string value);

	void handle(string sender, string message);

	void setName(ActorName value);

protected:
	bool resourceConflict;

private:
//	OpenThreads::Mutex stateMutex;
	pthread_mutex_t pStateMutex;

};

#endif
