#include "HelloWorldPrinter.h"
#include <string>
#include <vector>
#include <iostream>
#include "utility.h"

using namespace std;

HelloWorldPrinter::HelloWorldPrinter()
{
	behavior.operations.push_back("printHelloWorld");
	behavior.operations.push_back("setRepeatTrue");
	behavior.operations.push_back("setRepeatFalse");
}

HelloWorldPrinter::~HelloWorldPrinter()
{

}

void HelloWorldPrinter::handle(string sender, string message)
{
	cout << "Actor" << endl;

	if(message == "printHelloWorld")
	{
		if(repeat)
			printHelloWorld();
		printHelloWorld();
	}
	else if(message == "setRepeatTrue")
	{
		repeat = true;
		cout << name.uan << " : repeat set to true." << endl;
	}
	else if(message == "setRepeatFalse")
	{
		repeat = false;
		cout << name.uan << " : repeat set to false." << endl;
	}
}

string HelloWorldPrinter::handle_synch(string sender, string message)
{
	if(message == "printHelloWorld")
	{
		if(repeat)
			printHelloWorld();
		printHelloWorld();

		return "";
	}
	else if(message == "setRepeatTrue")
	{
		repeat = true;
		cout << name.uan << " : repeat set to true." << endl;

		return "";
	}
	else if(message == "setRepeatFalse")
	{
		repeat = false;
		cout << name.uan << " : repeat set to false." << endl;

		return "";
	}
	else
		return Actor::handle_synch(sender, message);	
}

void HelloWorldPrinter::printHelloWorld()
{
	cout << "Hello World!" << endl;
}

