#ifndef RRBASE_H_
#define RRBASE_H_

#include "Actor.h"
//#include <OpenThreads/Mutex>
#include <pthread.h>

class RRBase: public Actor
{
public:
	RRBase(string roleIn);

	~RRBase();

	string handle_synch(string sender, string message);

	virtual string check_constraints(string destinationActor, string operation,
		string parameters, string senderActor, string senderRole,
		string destinationRole) = 0;

	string getOwnerRole();

	void setName(ActorName value);

	virtual void updateState(string stateName,string value) = 0;

	void handle(string sender, string message);

private:
	string ownerRole;
	//OpenThreads::Mutex stateMutex;
	pthread_mutex_t pStateMutex;

};

#endif
