#ifndef UANMANAGER_H_
#define UANMANAGER_H_

#include <map>
#include <string>
//#include <OpenThreads/Mutex>
#include <pthread.h>
#include <vector>
#include <map>

#include "ActorName.h"
#include "Actor.h"

class UANManager
{
public:
	static UANManager *Instance();

	~UANManager();

	Actor *getLocalActor(string uan);

	ActorName generateName(string actorType, Actor *actor, bool role);

	void getActorNames(vector<ActorName> &data);

protected:
	UANManager();

private:
	static UANManager *pinstance;

//	OpenThreads::Mutex mutex;
	pthread_mutex_t pMutex; 

	
	
	//uan and actor object map
	map<string,Actor*> actors;

	//actor type and highest instance number map
	map<string,int> counters;

	vector<ActorName> actorNames;
};

#endif
