#include "utility.h"
#include <string>
#include <vector>
#include <cctype>
#include <iostream>
#include <time.h>


using namespace std;

vector<string> Utility::split(const string& InputString) {
	vector<string> ret;
	//typedef string::size_type string_size;
	int i = 0;
    int j;
	string block;

	while (i != (int)InputString.size()) {

		// ignore leading blanks
		while (i != (int)InputString.size() && isspace(InputString[i])) {
			i++;
		}

	    // find end of next word
		j = i;
		while ( j != ((int)InputString.size()) && !isspace(InputString[j])) {
			++j;
		}

		// if we found some nonwhitespace characters
		if (i != j) {
			// copy from s starting at i and taking j-1 chars
			ret.push_back(InputString.substr(i, j-i));
			i = j;
		}
	}
	return ret;
}

/*vector<string> Utility::split(const string& InputString,char delimiter)
{
	vector<string> ret;
	//typedef string::size_type string_size;
	int i = 0;
    int j;
	string block;

	while (i != InputString.size())
	{
		// ignore leading blanks
		while (i != InputString.size() && (InputString[i] == delimiter))
		{
			i++;
		}

	    // find end of next word
		j = i;
		while ((j != InputString.size()) && (InputString[j] != delimiter))
		{
			++j;
		}

		// if we found some nonwhitespace characters
		if (i != j)
		{
			// copy from s starting at i and taking j-1 chars
			ret.push_back(InputString.substr(i, j-i));
			i = j;
		}
	}
	return ret;
}*/

vector<string> Utility::split(const string &inputString,char delimiter,int maxSubstrings)
{
	vector<string> result;
	string temp;
	char c;
	bool done = false;
	int i;

	temp = "";
	for(i = 0; i < (int)inputString.size(); i++)
	{
		c = inputString[i];

		if(c != delimiter)
			temp += c;
		else
		{
			c = inputString[i];

			if(c != delimiter)
				temp += c;
			else
			{
				result.push_back(temp);
				temp = "";

				if((int)result.size() == (maxSubstrings - 1))
				{
					done = true;
					break;
				}
			}
		}
	}
	
	if(!done)
		result.push_back(temp);
	else
	{
		result.push_back(inputString.substr(i + 1));
	}

	return result;
}

vector<string> Utility::split(const string& InputString,char delimiter)
{
	vector<string> result;
	string temp;
	char c;

	temp = "";
	for(int i = 0; i < (int)InputString.size(); i++)
	{
		c = InputString[i];

		if(c != delimiter)
			temp += c;
		else
		{
			result.push_back(temp);
			temp = "";
		}
	}
	
	result.push_back(temp);

	return result;
}

void Utility::sleep(int n)
{
		time_t start_time, cur_time;

        time(&start_time);
        do
		{
           time(&cur_time);
		}
        while((cur_time - start_time) < n);

}

char* Utility::stringToChar(string s)
{
	char *c = new char[s.size() + 1];

	c = strcpy(c,s.c_str());

	return c;
}

