#ifndef AAPLATFORM_H_
#define AAPLATFORM_H_

#include <iostream>
#include <string>
#include <queue>
#include "Actor.h"
#include "ActorName.h"
#include "PropertyReader.h"

using namespace std;

class  AAPlatform
{
public:
	static AAPlatform* Instance();
	
	virtual ~AAPlatform (void);
	
	ActorName create (string actorName);
	
	void send (string actorName, string operation);

	string getPlatformName();

	string getNamingService();

	string getCoordinatorRepresentative();

	string getRR(string roleName);

	string getCR();

	void startup(string propertyFileName);
	
	int getMode();

protected:
	
	AAPlatform();
	
private:
	static AAPlatform* pinstance;

	PropertyReader pr;
};

#endif /* AAPLATFORM_H_  */


