#include "ActorCache.h"

ActorCache *ActorCache::pinstance = 0;

ActorCache* ActorCache::Instance()
{
	if(pinstance == 0)
		pinstance = new ActorCache();

	return pinstance;
}

ActorCache::ActorCache()
{
	data.clear();
}

ActorCache::~ActorCache()
{
}

int ActorCache::size()
{
	return data.size();
}

/*int ActorCache::indexOfActorName(string actorName)
{
	for(int i = 0; i < data.size(); i++)
	{
		ActorCacheItem item = data[i];
		if(item.actorName == actorName)
			return i;
	}
	return -1;
}*/

bool ActorCache::get(string actorName, Messenger_var &objRef)
{
	/*int index = indexOfActorName(actorName);
	if(index >= 0)
	{
		objRef = data[index].objRef;
		return true;
	}
	else
		return false;*/

	if(data.find(actorName) != data.end())
	{
		objRef = data[actorName];
		return true;
	}
	else
		return false;
}

void ActorCache::put(string actorName, Messenger_var objRef)
{
	/*int index = indexOfActorName(actorName);
	if(index >= 0)
	{
		data[index].objRef = objRef;
	}
	else
	{
		ActorCacheItem item;
		item.actorName = actorName;
		item.objRef = objRef;
		data.push_back(item);
	}*/

	data[actorName] = objRef;
}

