#ifndef ACTORCACHE_H_
#define ACTORCACHE_H_

#include <string>
//#include <vector>
#include <map>
#include "MessengerC.h"

using namespace std;

struct ActorCacheItem
{
	string actorName;
	Messenger_var objRef;
};

class ActorCache
{
public:
	static ActorCache* Instance();

	~ActorCache();

	bool get(string actorName,Messenger_var &objRef);

	void put(string actorName,Messenger_var objRef);

	int size();

protected:
	ActorCache();

private:
	map<string,Messenger_var> data;

	static ActorCache *pinstance;
};

#endif

