
#ifndef _ACTORFACTORYTHREAD_H_
#define _ACTORFACTORYTHREAD_H_

//#include <sys/types.h>
#include <cctype>
#include <cstdlib>
#include <iostream>
#include <pthread.h>
#include <queue>
#include <string>
#include "AAPlatform.h"
#include "utility.h"
#include "MessengerI.h"
#include "ORBThreadPool.h"
#include "tao/ORB_Core.h"
#include "ace/Log_Msg.h"
#include "orbsvcs/CosNamingC.h"
#include "orbsvcs/Naming/Naming_Server.h"
#include "tao/Utils/ORB_Manager.h"
#include "ace/Get_Opt.h"

using namespace std;

/*
#ifdef _WIN32
#include <process.h>
#define getpid() _getpid()
#else
#include <unistd.h>
#endif
*/

/*
static OpenThreads::Thread* CurrentChecker()
{
	return OpenThreads::Thread::CurrentThread();
};
*/

class ActorFactoryThread  
{

public:

	ActorFactoryThread();

    	~ActorFactoryThread();
		
	void setDone(bool value);

	bool isDone();
    

	CORBA::ORB_var getORB();

	PortableServer::POA_var getPOA();
	
	CosNaming::NamingContext_var getNameService();
	
	 void run();
	

private:
	
    	volatile bool done;
 //   OpenThreads::Mutex doneMutex;

	pthread_mutex_t pDoneMutex;

	CORBA::ORB_var orb;
	PortableServer::POA_var poa;
	CosNaming::NamingContext_var namingRoot;

	

};

#endif

