#include <string>
#include <iostream>
#include "ConcurrentPing.h"
#include <limits.h>

using namespace std;

int *ConcurrentPing::startTimes = new int[STATIC_CRAP_SIZE];
int *ConcurrentPing::endTimes = new int[STATIC_CRAP_SIZE];

ConcurrentPing::ConcurrentPing()
{
	number = 0;
	for(int i = 0; i < STATIC_CRAP_SIZE; i++)
	{
		startTimes[i] = INT_MAX;
		endTimes[i] = 0;
	}

	behavior.operations.push_back("set");
	behavior.operations.push_back("make");
	behavior.operations.push_back("start");
	behavior.operations.push_back("show");
}

ConcurrentPing::~ConcurrentPing()
{

}

void ConcurrentPing::handle(string sender,string message)
{
	string operation = message;

	if(operation == "set1")
	{
		number = 1;
	}
	else if(operation == "set10")
	{
		number = 10;
	}
	else if(operation == "set20")
	{
		number = 20;
	}
	else if(operation == "set40")
	{
		number = 40;
	}
	else if(operation == "set60")
	{
		number = 60;
	}
	else if(operation == "set80")
	{
		number = 80;
	}
	else if(operation == "set100")
	{
		number = 100;
	}
	else if(operation == "make")
	{
		cout << "Creating ping actors..." << endl;
		actors.clear();
		for(int i = 0; i < STATIC_CRAP_SIZE; i++)
		{
			ActorName name = create("PingActor");
			sendUnconstrained(name.uan,"default");
			actors.push_back(name);
		}
	}
	else if(operation == "start")
	{
		for(int i = 0; i < number; i++)
			sendUnconstrained(actors[i].uan,"start");
	}
	else if(operation == "show")
	{
		int start = INT_MAX;
		int end = 0;
		int i;

		for(i = 0; i < number; i++)
		{
			if(startTimes[i] < start)
				start = startTimes[i];

			if(endTimes[i] > end)
				end = endTimes[i];
		}

		for(i = 0; i < number; i++)
		{
			int delta = endTimes[i] - startTimes[i];
			cout << "Pair " << i << " Time: " << delta << endl;
		}

		int delta = end - start;
		cout << "Total time: " << delta << endl;
	}

	cout << "Actor count set to: " << number << endl;
}

