#ifndef COORDINATOR_H_
#define COORDINATOR_H_
#include "Actor.h"
//#include <OpenThreads/Mutex>
#include<pthread.h>
#include <vector>

class Coordinator: public Actor
{
public:
	Coordinator();

	~Coordinator();

	string handle_synch(string sender, string message);

	void handle(string sender, string message);

protected:
	void manageStateUpdate(string stateName,string value);

	void updateState(string stateName, string value);

	vector<string> representatives;

	//OpenThreads::Mutex updateMutex;
	pthread_mutex_t pUpdateMutex;

	bool resourceConflict;
};

#endif
