#include "HelloWorldPrinterRRFDM.h"

HelloWorldPrinterRRFDM::HelloWorldPrinterRRFDM(): RRFDM("HelloWorldPrinterRole")
{

}

HelloWorldPrinterRRFDM::~HelloWorldPrinterRRFDM()
{

}

string HelloWorldPrinterRRFDM::check_constraints(string destinationActor, string operation,
	string parameters, string senderActor, string senderRole,
	string destinationRole)
{
	RRFDM::check_constraints(destinationActor,operation,parameters,senderActor,senderRole,destinationRole);

	cout << "HelloWorldPrinterRRFDM is checking the constraints..." << endl;

	if(senderRole == "HelloWorldSenderType1Role" && (!qosLevel))
	{
		call(destinationActor,"setRepeatFalse");
	}
	else if(senderRole == "HelloWorldSenderType1Role" && qosLevel)
	{
		call(destinationActor,"setRepeatTrue");
	}
	else if(senderRole == "HelloWorldSenderType2Role")
	{
		call(destinationActor,"setRepeatTrue");
	}

	return "";
}

void HelloWorldPrinterRRFDM::updateState(string stateName, string value)
{
	if(stateName == "qosLevel")
	{
		qosLevel = (value == "high");
		cout << "QoSLevel set to " << value << endl;
	}
}

void HelloWorldPrinterRRFDM::handle(string sender, string message)
{

}
