#ifndef HELLOWORLDPRINTERROLE_H_
#define HELLOWORLDPRINTERROLE_H_

#include "RoleBase.h"

class HelloWorldPrinterRole: public RoleBase
{
public:
	HelloWorldPrinterRole();

	~HelloWorldPrinterRole();

	void updateState(string stateName, string value);

	string check_constraints(string destinationActor, string operation,
		string parameters, string senderActor, string senderRole,
		string destinationRole);

	void handle(string sender, string message);

	string handle_synch(string sender, string message);

private:
	bool qosLevel;
};

#endif

