#include "HelloWorldSender.h"

HelloWorldSender::HelloWorldSender()
{
	behavior.operations.push_back("start");
	behavior.operations.push_back("startType2");
	behavior.attributes["type"] = "1";
}

HelloWorldSender::~HelloWorldSender()
{

}

void HelloWorldSender::handle(string sender,string message)
{
	cout << "Actor" << endl;

	if(message == "start")
	{
		sendHelloWorld();
	}
	else if(message == "startType2")
	{
		become("2");
		sendHelloWorld();
	}
	else if(message == "one")
	{
		become("1");
	}
	else if(message == "two")
	{
		become("2");
	}
}

void HelloWorldSender::become(string state)
{
	if(state == "2")
	{
		behavior.attributes["type"] = "2";
	}
	else
	{
		behavior.attributes["type"] = "1";
	}

	//THIS MUST BE CALLED IF YOU WANT THE ROLE TO CHANGE!!!
	Actor::become(state);
}

void HelloWorldSender::sendHelloWorld()
{
	cout << "HelloWorldSender actor sending a message..." << endl;
	send("uan:HelloWorldPrinter:second:1","printHelloWorld");
}

