#ifndef MESSAGEMANAGER_H_
#define MESSAGEMANAGER_H_

#include "MessengerC.h"
#include "orbsvcs/CosNamingC.h"
#include <iostream>
#include <string>
#include <map>

//#define MESSAGEMANAGER_DISABLEOPTIMIZATION
//#define MESSAGEMANAGER_DISABLELOCALCALLS

using namespace std;

class  MessageManager
{
public:	
	virtual ~MessageManager ();
	
	void send (string sender,string actorName, string message);

	void sendUnconstrained(string sender, string actorName, string message);

	string call (string sender,string actorName, string message);

	static MessageManager* Instance();
protected:
	MessageManager();
	
private:
	void action (string sender,string actorName, string message);

	string action_synch (string sender,string actorName, string message);
	
	CosNaming::NamingContext_var root;

	static MessageManager *pinstance;

	CORBA::ORB_var orb;
};

#endif /* MESSAGEMANAGER_H_  */

