#ifndef ORBTHREADPOOL_H_
#define ORBTHREADPOOL_H_

#include <ace/Task.h>

class ORBThreadPool: public ACE_Task_Base
{
public:
	ORBThreadPool(CORBA::ORB_ptr orbPtr): orb(CORBA::ORB::_duplicate(orbPtr)) {};

	virtual ~ORBThreadPool() {};

	virtual int svc()
	{
		orb->run();
		return 0;
	}

private:
	CORBA::ORB_var orb;
};

#endif

