#include "RRFDM.h"
#include "AAPlatform.h"
#include <iostream>

using namespace std;

RRFDM::RRFDM(string role) : RRBase(role)
{

}

RRFDM::~RRFDM()
{

}

string RRFDM::check_constraints(string destinationActor, string operation,
		string parameters, string senderActor, string senderRole,
		string destinationRole)
{
	//check constraints here
	//do whatever checking constraints requires you to do

	//prepare the event to send to the CR
	string event = "ask|constraintType|" + getOwnerRole() + "|" + operation + "|" + parameters + "|" + senderRole + "|" + destinationRole;

	//get the name of the CR
	string crName = AAPlatform::Instance()->getCR();

	//send the event to the CR
	cout << "Role representative is sending an \"ask\" event to the coordinator representative..." << endl;
	string crResult = call(crName,event);

	//combine the result from checking the constraints here with the result from the CR
	//and return that back

	return "";
}

void RRFDM::updateState(string stateName, string value)
{

}

