#include "MessengerI.h"
#include "MessageReceiver.h"
#include <CosNamingC.h>
#include <iostream>
#include <fstream>
#include <iostream>

using namespace std;


int MessageReceiver::action(char *actorName)
{
	/*int argc = 1;
	char *argv[1];
	argv[0] = "Server";
	//argv[1] = "-ORBInitRef";
	//argv[2] = "NameService=corbaloc:iiop:p4ht:2809/NameService";

	try {
		//Initialize the ORB.	
		CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);

		//Get a reference to the RoorPOA.
		CORBA::Object_var obj = orb->resolve_initial_references("RootPOA");
		PortableServer::POA_var poa = PortableServer::POA::_narrow(obj.in());

		//Activate the POAManager.
		PortableServer::POAManager_var mgr = poa->the_POAManager();
		mgr->activate();

		//Create a servant.
		Messenger_i servant;


		//Find the Naming Service
		CORBA::Object_var naming_obj = 
			orb->resolve_initial_references("NameService");
		
		CosNaming::NamingContext_var root =
			CosNaming::NamingContext::_narrow(naming_obj.in());
		if (CORBA::is_nil(root.in())) {
			std::cerr << "Nil Naming Context reference" << std::endl;
			return 1;
		}

		//Bind the example Naming Context, if necessary
		CosNaming::Name name;
		name.length(1);
		name[0].id = CORBA::string_dup("example");
		try {
			CORBA::Object_var dummy = root->resolve(name);
		}
		catch (const CosNaming::NamingContext::NotFound &) {
			CosNaming::NamingContext_var dummy = root->bind_new_context (name);
		}

		//Bind the Messenger object
		name.length(2);
		name[1].id = CORBA::string_dup(actorName);

		//Register the servant with the RootPOA
		PortableServer::ObjectId_var oid = 
			poa->activate_object(&servant);
		CORBA::Object_var messenger_obj = poa->id_to_reference(oid.in());
		root->rebind(name, messenger_obj.in());
		
		cout << actorName << " object bound in Naming Service" << endl;

		//Accept requests from clients.
		orb->run();
		orb->destroy();

		return 0;
	}
	catch (CORBA::Exception& ex) {
		std::cerr << "MessengerServer CORBA exception: "  << ex << endl;
	}

	*/
	cout << "This message should not be displayed!" << endl;
	return 0;
}
